 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

/*
 * This class is used to display the About Unitex window
 *
 */
public class AboutUnitexFrame extends JInternalFrame implements InternalFrameListener{
	MyTextArea text=new MyTextArea();
	JScrollPane scroll;
	public static AboutUnitexFrame frame;
	JTextArea comment=new JTextArea();
	JScrollPane commentScroll;
	
	public AboutUnitexFrame() {
		super("About Unitex",true,true);
		JPanel top=new JPanel();
		top.setOpaque(true);
		top.setLayout(new BorderLayout());
		
		scroll=new JScrollPane(text);
		JPanel up=new JPanel();
		up.setOpaque(true);
		up.setLayout(new BorderLayout());
		JPanel image=new JPanel();
		image.setBorder(new EmptyBorder(4,3,1,1));
		image.setLayout(new BorderLayout());
		image.add(new JLabel(new ImageIcon("Unitex.jpg")));
		up.add(image,BorderLayout.WEST);
		JPanel info=new JPanel();
		info.setBorder(new TitledBorder("Unitex"));
		info.setLayout(new BorderLayout());
		commentScroll=new JScrollPane(comment);
		info.add(commentScroll,BorderLayout.CENTER);
		up.add(info,BorderLayout.CENTER);
		top.add(up,BorderLayout.NORTH);
		JPanel licence=new JPanel();
		licence.setBorder(new TitledBorder("GNU General Public Licence:"));
		licence.setLayout(new BorderLayout());
		licence.add(scroll,BorderLayout.CENTER);
		top.add(licence,BorderLayout.CENTER);
		setContentPane(top);
		pack();
		setBounds(100,100,500,400);
		setVisible(false);
		addInternalFrameListener(this);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	}


	public static void showFrame() {
		if (frame==null) {
			frame=new AboutUnitexFrame();
			UnitexFrame.mainFrame.desktop.add(frame,UnitexFrame.DOCLAYER);
			frame.comment.setWrapStyleWord(true);
			frame.comment.setLineWrap(true);
			frame.comment.setEditable(false);
			frame.comment.setText("Copyright (C) 2001-2002\n");
			frame.comment.append("Universit de Marne-la-Valle <unitex@univ-mlv.fr>\n");
			frame.comment.append("(Web site: http://www-igm.univ-mlv.fr/~unitex)\n");
			frame.comment.append("\nUnitex is a linguistic software engine. ");
			frame.comment.append("This software uses the Unicode 3.0 standard for character encoding.\n");
			frame.comment.append("\n");
			frame.comment.append("Unitex is free software. You can redistribute it and/or modify it under the terms of the GNU General Public License.\n");
			frame.text.setWrapStyleWord(true);
			frame.text.setLineWrap(true);
			frame.text.setEditable(false);
			try {
				frame.text.load(new File(Config.getApplicationDir()+"Licence.txt"));
			} catch(java.io.IOException E) {
				System.out.println("Cannot open the licence file");
			}
		}
		try { 
		    frame.setSelected(true); 
		    frame.setIcon(false);
		} catch (java.beans.PropertyVetoException e2) {}
		frame.setVisible(true);
	}	


	public void internalFrameActivated(InternalFrameEvent e) {}
	public void internalFrameClosed(InternalFrameEvent e) {}
	public void internalFrameClosing(InternalFrameEvent e) {
		frame.setVisible(false);
	}
	public void internalFrameDeactivated(InternalFrameEvent e) {}
	public void internalFrameDeiconified(InternalFrameEvent e) {}
	public void internalFrameIconified(InternalFrameEvent e) {}
	public void internalFrameOpened(InternalFrameEvent e) {}

}