 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.nio.charset.Charset;
import java.nio.channels.*;

/*
 * This class is used to display DELA check results
 *
 */
public class CheckResultFrame extends JInternalFrame implements InternalFrameListener {
	MyTextArea text=new MyTextArea();
	JScrollPane scroll;
	public static CheckResultFrame frame;


	public CheckResultFrame() {
		super("",true,true,true,true);
		JPanel top=new JPanel();
		top.setOpaque(true);
		top.setLayout(new BorderLayout());
		top.setBorder(new EmptyBorder(2,2,2,2));
		scroll=new JScrollPane(text);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		JPanel middle=new JPanel();
		middle.setOpaque(true);
		middle.setLayout(new BorderLayout());
		middle.setBorder(BorderFactory.createLoweredBevelBorder());
		middle.add(scroll,BorderLayout.CENTER);
		top.add(middle,BorderLayout.CENTER);
		setContentPane(top);
		pack();
		setBounds(100,100,600,600);
		setVisible(false);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addInternalFrameListener(this);
	}
	
	
	public static void init() {
		frame=new CheckResultFrame();
	}

	
	public static CheckResultFrame getFrame() {
		return frame;
	}

	
	
	public static void load(String dela) {
		frame.text.setFont(Config.getCurrentTextFont());
		frame.text.setLineWrap(true);
		frame.text.setEditable(false);
		try {
			frame.text.load(new File(dela));
		} catch (java.io.IOException e) {return;}
		frame.setTitle("Check Results");
		frame.setVisible(true);
		try { 
		    frame.setIcon(false);
		    frame.setSelected(true); 
		} catch (java.beans.PropertyVetoException e2) {}
	}
	
	
	public static void close() {
		frame.setVisible(false);
		frame.text.setDocument(new PlainDocument());
		System.gc();
	}
	
	
	public void internalFrameActivated(InternalFrameEvent e) {}
	public void internalFrameClosed(InternalFrameEvent e) {}
	public void internalFrameClosing(InternalFrameEvent e) {
		close();
	}
	public void internalFrameDeactivated(InternalFrameEvent e) {}
	public void internalFrameDeiconified(InternalFrameEvent e) {}
	public void internalFrameIconified(InternalFrameEvent e) {}
	public void internalFrameOpened(InternalFrameEvent e) {}

}