 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

/*
 * This class is used to display command lines
 *
 */
public class Console extends JInternalFrame implements InternalFrameListener{
	JTextArea text=new JTextArea();
	JScrollPane scroll;
	public static Console console;
	
	public Console() {
		super("Console",true,true);
		scroll=new JScrollPane(text);
		JPanel middle=new JPanel();
		middle.setOpaque(true);
		middle.setLayout(new BorderLayout());
		middle.setBorder(BorderFactory.createLoweredBevelBorder());
		middle.add(scroll,BorderLayout.CENTER);
		JPanel top=new JPanel();
		top.setOpaque(true);
		top.setLayout(new BorderLayout());
		top.setBorder(new EmptyBorder(2,2,2,2));
		top.add(middle,BorderLayout.CENTER);
		setContentPane(top);
		pack();
		setBounds(100,100,600,400);
		setVisible(false);
		addInternalFrameListener(this);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	}
	
	
	public static void add(String command) {
		console.text.append(command+"\n");
	}


	public static void init() {
		console=new Console();
	}
	
	public static Console getFrame() {
		return console;
	}
	
	public void internalFrameActivated(InternalFrameEvent e) {}
	public void internalFrameClosed(InternalFrameEvent e) {}
	public void internalFrameClosing(InternalFrameEvent e) {
		console.setVisible(false);
	}
	public void internalFrameDeactivated(InternalFrameEvent e) {}
	public void internalFrameDeiconified(InternalFrameEvent e) {}
	public void internalFrameIconified(InternalFrameEvent e) {}
	public void internalFrameOpened(InternalFrameEvent e) {}

}