 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.io.*;
import java.lang.System;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.nio.charset.Charset;
import java.nio.channels.*;

/*
 * This class is used to preference window
 *
 */
public class GlobalPreferenceFrame extends JInternalFrame implements InternalFrameListener {
	
	public JPanel panel=new JPanel();
	public JPanel upPanel=new JPanel();
	public JPanel downPanel=new JPanel();
	public JPanel page1=new JPanel();
	public JPanel page2=new JPanel();
	public JPanel page3=new JPanel();
	public JTabbedPane tabbedPane=new JTabbedPane(JTabbedPane.TOP);
	public JButton OK=new JButton("OK");
	public JButton CANCEL=new JButton("Cancel");
	public static GlobalPreferenceFrame frame;
	public JTextField privateDirectory=new JTextField("");
	public JButton setPrivateDirectory=new JButton("Set...");
	public JTextField textFont=new JTextField("");
	public JButton setTextFont=new JButton("Set...");
	public JTextField concordanceFont=new JTextField("");
	public JButton setConcordanceFont=new JButton("Set...");
	public JTextField htmlViewer=new JTextField("");
	public JButton setHtmlViewer=new JButton("Set...");
	

	public JPanel upPanel_=new JPanel();
	public JPanel downPanel_=new JPanel();
	JPanel displayPanel=new JPanel();
	JPanel display1=new JPanel();
	JPanel display2=new JPanel();
	JPanel display3=new JPanel();
	JPanel display4=new JPanel();
	JPanel display5=new JPanel();
	JPanel colorPanel=new JPanel();
	JPanel AntialiasingPanel=new JPanel();
	JPanel fontPanel=new JPanel();
	JPanel buttonPanel=new JPanel();
	JCheckBox antialiasingCheckBox=new JCheckBox("Enable antialising for rendering graphs",false);
	JCheckBox dateCheckBox=new JCheckBox();
	JCheckBox filenameCheckBox=new JCheckBox();
	JCheckBox pathnameCheckBox=new JCheckBox();
	JCheckBox frameCheckBox=new JCheckBox();
	JCheckBox rightToLeftCheckBox=new JCheckBox();
	JButton color1=new JButton("     ");
	JButton color2=new JButton("     ");
	JButton color3=new JButton("     ");
	JButton color4=new JButton("     ");
	JButton color5=new JButton("     ");
	JButton background=new JButton("Set...");
	JButton foreground=new JButton("Set...");
	JButton subgraph=new JButton("Set...");
	JButton selected=new JButton("Set...");
	JButton comment=new JButton("Set...");
	JButton input=new JButton("Input");
	JButton output=new JButton("Output");
	JButton RESET_TO_DEFAULT=new JButton("Reset to Default");
	JLabel label1=new JLabel("  Background:  ",JLabel.LEFT);
	JLabel label2=new JLabel("  Foreground:  ",JLabel.LEFT);
	JLabel label3=new JLabel("  Auxiliary Nodes:  ",JLabel.LEFT);
	JLabel label4=new JLabel("  Selected Nodes:  ",JLabel.LEFT);
	JLabel label5=new JLabel("  Comment Nodes:  ",JLabel.LEFT);
	JLabel inputLabel=new JLabel("",JLabel.LEFT);
	JLabel outputLabel=new JLabel("",JLabel.LEFT);
	

	
	public GlobalPreferenceFrame() {
		super("",false,true,false,false);
		constructPanel();
		setContentPane(panel);
		pack();
		setBounds(200,200,400,395);
		setVisible(false);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addInternalFrameListener(this);
	}
	

	
	public static void init() {
		frame=new GlobalPreferenceFrame();
	}

	

	public static GlobalPreferenceFrame getFrame() {
		return frame;
	}


	
	public static void showFrame() {
		Preferences.temp=Preferences.pref.getClone();
		frame.setTitle("Preferences for "+Config.getCurrentLanguage());
		frame.privateDirectory.setText(Config.getUserDir());
		frame.textFont.setText(""+Preferences.temp.textFont.getFontName()+"  "+Preferences.temp.textFontSize+"");
		frame.concordanceFont.setText(""+Preferences.temp.HtmlFontName+"  "+Preferences.temp.HtmlFontSize+"");
		frame.inputLabel.setText("  "+Preferences.temp.input.getFontName()+"  "+Preferences.temp.inputSize+"  ");
		frame.outputLabel.setText("  "+Preferences.temp.output.getFontName()+"  "+Preferences.temp.outputSize+"  ");
		frame.color1.setBackground(Preferences.temp.backgroundColor);
		frame.color2.setBackground(Preferences.temp.foregroundColor);
		frame.color3.setBackground(Preferences.temp.subgraphColor);
		frame.color4.setBackground(Preferences.temp.selectedColor);
		frame.color5.setBackground(Preferences.temp.commentColor);
		frame.dateCheckBox.setSelected(Preferences.temp.date);
		frame.filenameCheckBox.setSelected(Preferences.temp.filename);
		frame.pathnameCheckBox.setSelected(Preferences.temp.pathname);
		frame.frameCheckBox.setSelected(Preferences.temp.frame);
		frame.rightToLeftCheckBox.setSelected(Preferences.temp.rightToLeft);
		frame.antialiasingCheckBox.setSelected(Preferences.temp.antialiasing);
		if (Preferences.temp.htmlViewer==null) {frame.htmlViewer.setText("");}
		else {frame.htmlViewer.setText(Preferences.temp.htmlViewer);}
		frame.setVisible(true);
		try { 
		    frame.setSelected(true); 
		} catch (java.beans.PropertyVetoException e2) {}
	}
	


	public void constructPanel() {
		panel.setOpaque(true);
		panel.setLayout(new BorderLayout());
		constructUpPanel();
		constructDownPanel();
		panel.add(upPanel,BorderLayout.CENTER);
		panel.add(downPanel,BorderLayout.SOUTH);
	}



	public void constructUpPanel() {
		upPanel.setLayout(new BorderLayout());
		constructPage1();
		constructPage2();
		constructPage3();
		if (Config.getCurrentSystem()==Config.WINDOWS_SYSTEM) tabbedPane.addTab("Directory",page1);
		tabbedPane.addTab("Text Presentation",page2);
		tabbedPane.addTab("Graph Presentation",page3);
		upPanel.add(tabbedPane);
	}



	public void constructDownPanel() {
		downPanel.setLayout(new BorderLayout());
		JPanel tmp=new JPanel();
		tmp.setBorder(new EmptyBorder(2,2,2,2));
		tmp.setLayout(new GridLayout(1,2));
		JPanel tmp1=new JPanel();
		JPanel tmp2=new JPanel();
		tmp1.setBorder(new EmptyBorder(5,5,5,5));
		tmp2.setBorder(new EmptyBorder(5,5,5,5));
		tmp1.setLayout(new BorderLayout());
		tmp2.setLayout(new BorderLayout());
		OK.addMouseListener(new OKButtonListener());
		CANCEL.addMouseListener(new CANCELButtonListener());
		tmp1.add(OK);
		tmp2.add(CANCEL);
		tmp.add(tmp1);
		tmp.add(tmp2);
		downPanel.add(tmp,BorderLayout.EAST);
	}

	
	
	public void constructPage1() {
		page1.setLayout(new GridLayout(4,1));
		page1.setBorder(new EmptyBorder(5,5,5,5));
		JPanel tmp=new JPanel();
		tmp.setPreferredSize(new Dimension(180,60));
		tmp.setLayout(new GridLayout(2,1));
		JLabel label=new JLabel("Private Unitex directory (where all user's data is to be stored):");
		tmp.add(label);
		JPanel tmp2=new JPanel();
		tmp2.setLayout(new BorderLayout());
		privateDirectory.setEditable(false);
		privateDirectory.setBackground(Color.WHITE);
		tmp2.add(privateDirectory,BorderLayout.CENTER);
		setPrivateDirectory.addMouseListener(new SetPrivateDirectoryButtonListener());
		tmp2.add(setPrivateDirectory,BorderLayout.EAST);
		tmp.add(tmp2);
		page1.add(new JLabel(""));
		page1.add(tmp,BorderLayout.CENTER);
		page1.add(new JLabel(""));
		page1.add(new JLabel(""));
	}



	public void constructPage2() {
		textFont.setEnabled(false);
		concordanceFont.setEnabled(false);
		textFont.setDisabledTextColor(Color.black);
		concordanceFont.setDisabledTextColor(Color.black);
		page2.setLayout(new GridLayout(5,1));
		page2.setBorder(new EmptyBorder(5,5,5,5));
		JPanel tmp=new JPanel();
		tmp.setPreferredSize(new Dimension(180,60));
		tmp.setLayout(new GridLayout(2,1));
		tmp.add(new JLabel("Text Font:"));
		JPanel tmp2=new JPanel();
		tmp2.setLayout(new BorderLayout());
		tmp2.add(textFont,BorderLayout.CENTER);
		setTextFont.addMouseListener(new SetTextFontButtonListener());
		tmp2.add(setTextFont,BorderLayout.EAST);
		tmp.add(tmp2);
		page2.add(new JLabel(""));
		page2.add(tmp);
		JPanel tmp_=new JPanel();
		tmp_.setPreferredSize(new Dimension(180,60));
		tmp_.setLayout(new GridLayout(2,1));
		tmp_.add(new JLabel("Concordance Font:"));
		JPanel tmp2_=new JPanel();
		tmp2_.setLayout(new BorderLayout());
		tmp2_.add(concordanceFont,BorderLayout.CENTER);
		setConcordanceFont.addMouseListener(new SetConcordanceFontButtonListener());
		tmp2_.add(setConcordanceFont,BorderLayout.EAST);
		tmp_.add(tmp2_);
		page2.add(tmp_);
		JPanel tmp__=new JPanel();
		tmp__.setPreferredSize(new Dimension(180,60));
		tmp__.setLayout(new GridLayout(2,1));
		tmp__.add(new JLabel("Html Viewer:"));
		JPanel tmp3_=new JPanel();
		tmp3_.setLayout(new BorderLayout());
		tmp3_.add(htmlViewer,BorderLayout.CENTER);
		setHtmlViewer.addMouseListener(new SetHtmlViewerButtonListener());
		tmp3_.add(setHtmlViewer,BorderLayout.EAST);
		tmp__.add(tmp3_);
		page2.add(tmp__);
		page2.add(new JLabel(""));
	}
	

	
	public void constructPage3() {
		page3.setBorder(new EmptyBorder(5,5,5,5));
		GridBagLayout g=new GridBagLayout();
		page3.setLayout(g);
		GridBagConstraints c=new GridBagConstraints();
		constructDisplayPanel();
		constructColorPanel();
		constructAntialiasingPanel();
		constructFontPanel();
		constructButtonPanel();
		constructUpPanel_();
		constructDownPanel_();
		c.gridwidth=GridBagConstraints.REMAINDER;
		c.fill=GridBagConstraints.BOTH;
		c.anchor=GridBagConstraints.NORTH;
		g.setConstraints(upPanel_,c);
		page3.add(upPanel_);
		c.fill=GridBagConstraints.BOTH;
		g.setConstraints(downPanel_,c);
		page3.add(downPanel_);
	}
	
	
	
	void constructUpPanel_() {
		upPanel_.setBorder(new EmptyBorder(0,0,0,0));
		upPanel_.setLayout(new BorderLayout());
		upPanel_.add(displayPanel,BorderLayout.WEST);
		upPanel_.add(colorPanel,BorderLayout.CENTER);
	}



	void constructDownPanel_() {
		downPanel_.setBorder(new EmptyBorder(0,0,0,0));
		downPanel_.setLayout(new BorderLayout());
		downPanel_.add(AntialiasingPanel,BorderLayout.NORTH);
		downPanel_.add(fontPanel,BorderLayout.CENTER);
		downPanel_.add(buttonPanel,BorderLayout.EAST);
	}



	void constructDisplayPanel() {
		displayPanel.setBorder(new TitledBorder("Display"));
		displayPanel.setLayout(new GridLayout(5,1));
		dateCheckBox.setSelected(Preferences.temp.date);
		filenameCheckBox.setSelected(Preferences.temp.filename);
		pathnameCheckBox.setSelected(Preferences.temp.pathname);
		frameCheckBox.setSelected(Preferences.temp.frame);
		rightToLeftCheckBox.setSelected(Preferences.temp.rightToLeft);
		display1.setLayout(new BorderLayout());
		display2.setLayout(new BorderLayout());
		display3.setLayout(new BorderLayout());
		display4.setLayout(new BorderLayout());
		display5.setLayout(new BorderLayout());
		display1.add(dateCheckBox,BorderLayout.WEST);
		display1.add(new JLabel("Date  "),BorderLayout.CENTER);
		display2.add(filenameCheckBox,BorderLayout.WEST);
		display2.add(new JLabel("File Name  "),BorderLayout.CENTER);
		display3.add(pathnameCheckBox,BorderLayout.WEST);
		display3.add(new JLabel("Pathname  "),BorderLayout.CENTER);
		display4.add(frameCheckBox,BorderLayout.WEST);
		display4.add(new JLabel("Frame  "),BorderLayout.CENTER);
		display5.add(rightToLeftCheckBox,BorderLayout.WEST);
		display5.add(new JLabel("Right to Left  "),BorderLayout.CENTER);
		displayPanel.add(display1);
		displayPanel.add(display2);
		displayPanel.add(display3);
		displayPanel.add(display4);
		displayPanel.add(display5);
	}



	void build(GridBagConstraints c,int gx,int gy,int gw,int gh,int wx,int wy) {
		c.gridx=gx;
		c.gridy=gy;
		c.gridwidth=gw;
		c.gridheight=gh;
		c.weightx=wx;
		c.weighty=wy;
	}



	public void constructColorPanel() {
		colorPanel.setBorder(new TitledBorder("Colors"));
		GridBagLayout g=new GridBagLayout();
		colorPanel.setLayout(g);
		background.addMouseListener(new Color1Listener());
		foreground.addMouseListener(new Color2Listener());
		subgraph.addMouseListener(new Color3Listener());
		selected.addMouseListener(new Color4Listener());
		comment.addMouseListener(new Color5Listener());
		color1.setBackground(Preferences.temp.backgroundColor);
		color2.setBackground(Preferences.temp.foregroundColor);
		color3.setBackground(Preferences.temp.subgraphColor);
		color4.setBackground(Preferences.temp.selectedColor);
		color5.setBackground(Preferences.temp.commentColor);
		GridBagConstraints c=new GridBagConstraints();
		build(c,0,0,1,1,60,15);
		c.fill=GridBagConstraints.NONE;
		c.anchor=GridBagConstraints.EAST;
		g.setConstraints(label1,c);
		colorPanel.add(label1);
		build(c,1,0,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(color1,c);
		colorPanel.add(color1);
		build(c,2,0,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(background,c);
		colorPanel.add(background);
		build(c,0,1,1,1,60,15);
		c.fill=GridBagConstraints.NONE;
		c.anchor=GridBagConstraints.EAST;
		g.setConstraints(label2,c);
		colorPanel.add(label2);
		build(c,1,1,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(color2,c);
		colorPanel.add(color2);
		build(c,2,1,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(foreground,c);
		colorPanel.add(foreground);
		build(c,0,2,1,1,60,15);
		c.fill=GridBagConstraints.NONE;
		c.anchor=GridBagConstraints.EAST;
		g.setConstraints(label3,c);
		colorPanel.add(label3);
		build(c,1,2,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(color3,c);
		colorPanel.add(color3);
		build(c,2,2,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(subgraph,c);
		colorPanel.add(subgraph);
		build(c,0,3,1,1,60,15);
		c.fill=GridBagConstraints.NONE;
		c.anchor=GridBagConstraints.EAST;
		g.setConstraints(label4,c);
		colorPanel.add(label4);
		build(c,1,3,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(color4,c);
		colorPanel.add(color4);
		build(c,2,3,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(selected,c);
		colorPanel.add(selected);
		build(c,0,4,1,1,60,15);
		c.fill=GridBagConstraints.NONE;
		c.anchor=GridBagConstraints.EAST;
		g.setConstraints(label5,c);
		colorPanel.add(label5);
		build(c,1,4,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(color5,c);
		colorPanel.add(color5);
		build(c,2,4,1,1,20,0);
		c.fill=GridBagConstraints.HORIZONTAL;
		g.setConstraints(comment,c);
		colorPanel.add(comment);
	}



	public void constructAntialiasingPanel() {
		AntialiasingPanel.setBorder(new TitledBorder("Antialiasing"));
		AntialiasingPanel.setLayout(new BorderLayout());
		AntialiasingPanel.add(antialiasingCheckBox,BorderLayout.CENTER);
	}
	


	public void constructFontPanel() {
		fontPanel.setBorder(new TitledBorder("Fonts"));
		GridBagLayout g=new GridBagLayout();
		fontPanel.setLayout(g);
		GridBagConstraints c=new GridBagConstraints();
		input.addMouseListener(new inputListener());
		inputLabel.setText("  "+Preferences.temp.input.getFontName()+"  "+Preferences.temp.inputSize+"  ");
		output.addMouseListener(new outputListener());
		outputLabel.setText("  "+Preferences.temp.output.getFontName()+"  "+Preferences.temp.outputSize+"  ");
		build(c,0,0,1,1,60,15);
		c.fill=GridBagConstraints.BOTH;
		c.anchor=GridBagConstraints.WEST;
		g.setConstraints(input,c);
		fontPanel.add(input);
		build(c,1,0,1,1,20,0);
		c.fill=GridBagConstraints.VERTICAL;
		c.anchor=GridBagConstraints.WEST;
		g.setConstraints(inputLabel,c);
		fontPanel.add(inputLabel);
		build(c,0,1,1,1,60,15);
		c.fill=GridBagConstraints.BOTH;
		c.anchor=GridBagConstraints.WEST;
		g.setConstraints(output,c);
		fontPanel.add(output);
		build(c,1,1,1,1,20,0);
		c.fill=GridBagConstraints.VERTICAL;
		c.anchor=GridBagConstraints.WEST;
		g.setConstraints(outputLabel,c);
		fontPanel.add(outputLabel);
	}



	public void constructButtonPanel() {
		buttonPanel.setBorder(new EmptyBorder(8,5,1,1));
		buttonPanel.setLayout(new BorderLayout());
		RESET_TO_DEFAULT.addMouseListener(new RESET_TO_DEFAULTListener());
		buttonPanel.add(RESET_TO_DEFAULT,BorderLayout.CENTER);
	}
	
	
	public void refresh() {
		// here we refresh the components from the Preferences.temp preferences
		color1.setBackground(Preferences.temp.backgroundColor);
		color2.setBackground(Preferences.temp.foregroundColor);
		color3.setBackground(Preferences.temp.subgraphColor);
		color4.setBackground(Preferences.temp.selectedColor);
		color5.setBackground(Preferences.temp.commentColor);
		inputLabel.setText("  "+Preferences.temp.input.getFontName()+"  "+Preferences.temp.inputSize+"  ");
		outputLabel.setText("  "+Preferences.temp.output.getFontName()+"  "+Preferences.temp.outputSize+"  ");
		repaint();
	}



class RESET_TO_DEFAULTListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		Preferences.temp.inputSize=Preferences.pref.inputSize;
		Preferences.temp.outputSize=Preferences.pref.outputSize;
		Preferences.temp.input=new Font(Preferences.pref.input.getName(),Preferences.pref.input.getStyle(),(int)(Preferences.pref.inputSize/0.72));
		Preferences.temp.output=new Font(Preferences.pref.output.getName(),Preferences.pref.output.getStyle(),(int)(Preferences.pref.outputSize/0.72));
		Preferences.temp.backgroundColor=new Color(Preferences.pref.backgroundColor.getRGB());
		Preferences.temp.foregroundColor=new Color(Preferences.pref.foregroundColor.getRGB());
		Preferences.temp.subgraphColor=new Color(Preferences.pref.subgraphColor.getRGB());
		Preferences.temp.selectedColor=new Color(Preferences.pref.selectedColor.getRGB());
		Preferences.temp.commentColor=new Color(Preferences.pref.commentColor.getRGB());
		Preferences.temp.date=Preferences.pref.date;
		Preferences.temp.filename=Preferences.pref.filename;
		Preferences.temp.pathname=Preferences.pref.pathname;
		Preferences.temp.frame=Preferences.pref.frame;
		refresh();
		antialiasingCheckBox.setSelected(Preferences.temp.antialiasing);
		dateCheckBox.setSelected(Preferences.temp.date);
		filenameCheckBox.setSelected(Preferences.temp.filename);
		pathnameCheckBox.setSelected(Preferences.temp.pathname);
		frameCheckBox.setSelected(Preferences.temp.frame);
		rightToLeftCheckBox.setSelected(Preferences.temp.rightToLeft);
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class inputListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		new FontMenu(true);
		refresh();
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class outputListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		new FontMenu(false);
		refresh();
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class Color1Listener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		Preferences.temp.backgroundColor=JColorChooser.showDialog(UnitexFrame.mainFrame,
						"Background Color",
						Preferences.temp.backgroundColor);
        refresh();
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class Color2Listener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		Preferences.temp.foregroundColor=JColorChooser.showDialog(UnitexFrame.mainFrame,
						"Foreground Color",
						Preferences.temp.foregroundColor);
		refresh();
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class Color3Listener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		Preferences.temp.subgraphColor=JColorChooser.showDialog(UnitexFrame.mainFrame,
						"Auxiliary Nodes Color",
						Preferences.temp.subgraphColor);
		refresh();
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class Color4Listener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		Preferences.temp.selectedColor=JColorChooser.showDialog(UnitexFrame.mainFrame,
						"Selected Nodes Color",
						Preferences.temp.selectedColor);
		refresh();
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}


class Color5Listener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		Preferences.temp.commentColor=JColorChooser.showDialog(UnitexFrame.mainFrame,
						"Comment Nodes Color",
						Preferences.temp.commentColor);
		refresh();
		e.consume();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}

	public void internalFrameActivated(InternalFrameEvent e) {}	
	public void internalFrameClosed(InternalFrameEvent e) {}
	public void internalFrameClosing(InternalFrameEvent e) {
		setVisible(false);
	}
	public void internalFrameDeactivated(InternalFrameEvent e) {}
	public void internalFrameDeiconified(InternalFrameEvent e) {}
	public void internalFrameIconified(InternalFrameEvent e) {}
	public void internalFrameOpened(InternalFrameEvent e) {}



class SetPrivateDirectoryButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				JFileChooser f=new JFileChooser();
				f.setDialogTitle("Choose your private directory");
				f.setDialogType(JFileChooser.OPEN_DIALOG);
				f.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				if (f.showOpenDialog(null)!=JFileChooser.APPROVE_OPTION) return;
				if (Config.sameDirectory(f.getSelectedFile().getAbsolutePath(),Config.getUnitexDir())) {
	        		        JOptionPane.showMessageDialog(null,"You cannot choose the Unitex directory as your private one","Error",JOptionPane.ERROR_MESSAGE);
					return;
				}
				privateDirectory.setText(f.getSelectedFile().getAbsolutePath());
			}
		});
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}



class SetTextFontButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		new TextFontMenu();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}



class SetConcordanceFontButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		new ConcordanceFontMenu();
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}



class SetHtmlViewerButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				JFileChooser f=new JFileChooser();
				f.setDialogTitle("Choose your html viewer");
				f.setDialogType(JFileChooser.OPEN_DIALOG);
				if (f.showOpenDialog(null)!=JFileChooser.APPROVE_OPTION) return;
				htmlViewer.setText(f.getSelectedFile().getAbsolutePath());
			}
		});
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}



class OKButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}

	public void writeOneChar(FileOutputStream f,char c) {
		byte[] b=new byte[2];
		b[1]=(byte)(c/256);
		b[0]=(byte)(c%256);
		if (c=='\n') {
			writeOneChar(f,(char)0x0d);
		}
		try {
			f.write(b[0]);
			f.write(b[1]);
		} catch(IOException e) {e.printStackTrace();}
		
	}


	public void write_string(FileOutputStream f,String s) {
		int L=s.length();
		for (int i=0;i<L;i++)
			writeOneChar(f,s.charAt(i));
	}

	public void mouseReleased(MouseEvent e) {
		Preferences.temp.antialiasing=frame.antialiasingCheckBox.isSelected();
		Preferences.temp.htmlViewer=frame.htmlViewer.getText();
		Preferences.temp.date=frame.dateCheckBox.isSelected();
		Preferences.temp.filename=frame.filenameCheckBox.isSelected();
		Preferences.temp.pathname=frame.pathnameCheckBox.isSelected();
		Preferences.temp.frame=frame.frameCheckBox.isSelected();
		Preferences.temp.rightToLeft=frame.rightToLeftCheckBox.isSelected();
		Preferences.pref=Preferences.temp.getClone();
		File f=new File(Config.getUserCurrentLanguageDir()+"Config");
		if (f.exists()) {
			f.delete();
		}
		try {
			f.createNewFile();
			FileOutputStream out=new FileOutputStream(f);
			writeOneChar(out,(char)0xFEFF);
			write_string(out,"TEXT FONT NAME="+Preferences.temp.textFont.getName()+"\n");
			write_string(out,"TEXT FONT STYLE="+Preferences.temp.textFont.getStyle()+"\n");
			write_string(out,"TEXT FONT SIZE="+Preferences.temp.textFontSize+"\n");
			write_string(out,"CONCORDANCE FONT NAME="+Preferences.temp.HtmlFontName+"\n");
			write_string(out,"CONCORDANCE FONT HTML SIZE="+Preferences.temp.HtmlFontSize+"\n");
			write_string(out,"INPUT FONT NAME="+Preferences.temp.input.getName()+"\n");
			write_string(out,"INPUT FONT STYLE="+Preferences.temp.input.getStyle()+"\n");
			write_string(out,"INPUT FONT SIZE="+Preferences.temp.inputSize+"\n");
			write_string(out,"OUTPUT FONT NAME="+Preferences.temp.output.getName()+"\n");
			write_string(out,"OUTPUT FONT STYLE="+Preferences.temp.output.getStyle()+"\n");
			write_string(out,"OUTPUT FONT SIZE="+Preferences.temp.outputSize+"\n");
			write_string(out,"DATE="+Preferences.temp.date+"\n");
			write_string(out,"FILE NAME="+Preferences.temp.filename+"\n");
			write_string(out,"PATH NAME="+Preferences.temp.pathname+"\n");
			write_string(out,"FRAME="+Preferences.temp.frame+"\n");
			write_string(out,"RIGHT TO LEFT="+Preferences.temp.rightToLeft+"\n");
			write_string(out,"BACKGROUND COLOR="+String.valueOf(16777216+Preferences.temp.backgroundColor.getRGB())+"\n");
			write_string(out,"FOREGROUND COLOR="+String.valueOf(16777216+Preferences.temp.foregroundColor.getRGB())+"\n");
			write_string(out,"AUXILIARY NODES COLOR="+String.valueOf(16777216+Preferences.temp.subgraphColor.getRGB())+"\n");
			write_string(out,"COMMENT NODES COLOR="+String.valueOf(16777216+Preferences.temp.commentColor.getRGB())+"\n");
			write_string(out,"SELECTED NODES COLOR="+String.valueOf(16777216+Preferences.temp.selectedColor.getRGB())+"\n");
			write_string(out,"ANTIALIASING="+Preferences.temp.antialiasing+"\n");
			if (Preferences.temp.htmlViewer!=null) write_string(out,"HTML VIEWER="+Preferences.temp.htmlViewer+"\n");
			out.close();
			if (Config.getCurrentSystem()==Config.WINDOWS_SYSTEM) {
				// if we are under Windows, we must save the user dir
				if (privateDirectory.getText()!=null && !privateDirectory.getText().equals("")) {
					String rep=privateDirectory.getText();
					if (!rep.endsWith(File.separator)) rep=rep+File.separator;
					if (!rep.equalsIgnoreCase(Config.getUserDir())) {
						String userFile=Config.getUnitexDir()+"Users"+File.separator+Config.getUserName()+".cfg";
						File F=new File(userFile);
						if (F.exists()) F.delete();
						try {
							F.createNewFile();
							BufferedWriter bw=new BufferedWriter(new FileWriter(F));
							bw.write(rep,0,rep.length());
							bw.close();
						} catch (IOException e2) {e2.printStackTrace();}
						String message="Your private Unitex directory is now:\n\n";
						message=message+rep+"\n\n";
						message=message+"You must relaunch Unitex to take this change into account.";
						JOptionPane.showMessageDialog(null,message,"",JOptionPane.PLAIN_MESSAGE);
					}
				}
			}
		} catch (IOException e2) {e2.printStackTrace();}
		setVisible(false);
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}



class CANCELButtonListener implements MouseListener {
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {
		setVisible(false);
	}
	public void mouseMoved(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
	}
}

}