 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;


/**
  * This class describes a dialog box to handle the word list copy
  *
  */

public class ListCopyDialog extends JPanel {

	JTextField left,right;

    public ListCopyDialog() {
		super();
		setBorder(new EmptyBorder(10, 10, 10, 10));
		setLayout(new GridLayout(2,1));
		// placing the text
		add(new JLabel("Choose your left and right contexts:"));
		// placing the textfields
		left=new JTextField(5);
		left.setHorizontalAlignment(JTextField.RIGHT);
		right=new JTextField(5);
		JPanel inputPanel = new JPanel();
		inputPanel.setLayout(new FlowLayout());
		inputPanel.add(left);
		inputPanel.add(new JLabel("item"));
		inputPanel.add(right);
		add(inputPanel);
		// adding listeners for the text fields
		left.addKeyListener(new leftListener());
		right.addKeyListener(new rightListener());
    }


    public ListCopyDialog(String l,String r) {
		this();
		left.setText(l);
		right.setText(r);
	}
	
	

/*
 * Listens for a modification of the left context
 *
 */
 	public class leftListener implements KeyListener {
		public void keyTyped(KeyEvent e) {
			TextField.leftContext=left.getText();
		}
		public void keyReleased(KeyEvent e) {
			TextField.leftContext=left.getText();
		}
		public void keyPressed(KeyEvent e) {
			TextField.leftContext=left.getText();
		}
	}



/*
 * Listens for a modification of the right context
 *
 */
	public class rightListener implements KeyListener {
		public void keyTyped(KeyEvent e) {
			TextField.rightContext=right.getText();
		}
		public void keyReleased(KeyEvent e) {
			TextField.rightContext=right.getText();
		}
		public void keyPressed(KeyEvent e) {
			TextField.rightContext=right.getText();
		}
	}

}