 /*
  * Unitex
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
//---------------------------------------------------------------------------

//
// e:\unitex\data\french\corpus\femme.txt
//
// e:\unitex\data\korean\corpus\corpus.txt
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "unicode.cpp"
#include "FileName.cpp"
#include "Copyright.h"
//---------------------------------------------------------------------------

void usage() {
printf("%s",COPYRIGHT);
printf("Usage: Normalize <text>\n%s",CR);
printf("     <text> : text file to be normalized\n\n%s",CR);
printf("Turns every sequence of separator chars (space, tab, new line) into one.\n%s",CR);
printf("If a separator sequence contains a new line char, it is turned to a single new\n%s",CR);
printf("line; if not, it is turned into a single space.\n%s",CR);
printf("The result is stored in a file named file_name.snt.\n%s",CR);
}


void normalize(FILE* f,FILE* f_out) {
int c;
c=u_fgetc(f);
while (c!=EOF) {
      if (c==' ' || c=='\t' || c=='\n') {
         int enter=(c=='\n');
         while ((c=u_fgetc(f))==' ' || c=='\t' || c=='\n') {
               if (c=='\n') enter=1;
         }
         if (enter) u_fputc((unichar)'\n',f_out);
         else u_fputc((unichar)' ',f_out);
      }
      else {
         u_fputc((unichar)c,f_out);
         c=u_fgetc(f);
      }
}
}




int main(int argc, char **argv) {
FILE* f;
FILE* f_out;
char n[1000];
if (argc!=2) {
   usage();
   return 0;
}
name_without_extension(argv[1],n);
strcat(n,".snt");
f=u_fopen(argv[1],U_READ);
if (f==NULL) {
   fprintf(stderr,"Cannot open file %s\n",argv[1]);
   return 1;
}
f_out=u_fopen(n,U_WRITE);
if (f_out==NULL) {
   fprintf(stderr,"Cannot create file %s\n",n);
   u_fclose(f);
   return 1;
}
printf("Normalizing %s...\n%s",argv[1],CR);
normalize(f,f_out);
u_fclose(f);
u_fclose(f_out);
return 0;
}
//---------------------------------------------------------------------------
