 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

/*
 * This class is used to display stdout and stderr messages of external processes
 *
 */
public class ProcessInfoThread extends Thread {
	
	JTextArea txt;
	BufferedReader stream;
	boolean close_on_finish;
	ProcessInfoFrame parent_frame;
	JScrollBar scroll_bar;
	
	
	public ProcessInfoThread(JTextArea t,InputStream s,boolean b,ProcessInfoFrame f,JScrollBar scroll) {
		super();
		txt=t;
		close_on_finish=b;
		parent_frame=f;
		scroll_bar=scroll;
		stream=new BufferedReader(new InputStreamReader(s));
	}
	
	
	public void run() {
		String s;
		try {
			while ((s=stream.readLine())!=null) {
				if (!s.equals("")) {
					txt.append(s+"\n");
					scroll_bar.setValue(scroll_bar.getMaximum());
			}
			}
		} catch (IOException e) {}
		if (close_on_finish) {
			parent_frame.setVisible(false);
			parent_frame=null;
		}
		else {
			scroll_bar.setValue(scroll_bar.getMaximum());
		}
	}
	
}