 /*
  * Unitex 
  *
  * Copyright (C) 2001-2002 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
  */
import java.util.*;

/*
 * This class describes the box creation UNDO action
 *
 */
public class UNDOCreation implements UNDOAction {

	GraphFrame frame;
	Vector boxes=new Vector();
	

	public UNDOCreation(GraphFrame f,Vector v) {
		frame=f;
		int l=v.size();
		for (int i=0;i<l;i++) {
			GraphBox g=(GraphBox)v.get(i);
			boxes.add(g);
		}
	}
	
	
	public void undo() {
		int l=boxes.size();
		frame.graphicalZone.unSelectAllBoxes();
		for (int i=0;i<l;i++) {
			GraphBox g=(GraphBox)boxes.get(i);
			g.selected=false;
			frame.graphicalZone.selectedBoxes.add(g);
		}
		frame.graphicalZone.removeSelected();
	}
}